<?php

namespace Modules\DF\Factories;

class Guia{
    
    protected $factory;
    
    public function __construct(\Doctrine\ORM\EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function getGuides($DTINICIAL, $DTFINAL, $NRINSJURGUIA, $NRNOTAFISC, $CDFILIAL){
        $sql =  "
                    SELECT
                       FILIEMIT.CDFILIAL AS CDFILIEMIT,
                       FILIEMIT.NMFILIAL AS NMFILIEMIT,
                       FILIRECE.CDFILIAL AS CDFILIRECE,
                       FILIRECE.NMFILIAL AS NMFILIRECE,
                       NF.CDFILIAL AS CDFILIAL,
                       NF.NRLANCTONF AS NRLANCTONF,
                       NF.IDENTRSAIDOP AS IDENTRSAIDOP,
                       NF.NRNOTAFISC AS NRNOTAFISC,
                       NF.CDFEBOSID AS FEBOSID,
                       NF.NRINSJURNF AS NRINSJURGUIA,
                       NF.DTENTRSAID AS DTENTRSAID,
                       NF.DTEMISSAO AS DTEMISSAO,
                       NF.VRNOTAFISC AS VRNOTAFISC,
                       I.NRLANCTONFIT,
                       DECODE(I.NRLANCTONFIT, NULL, 'N', 'S') AS IDSTATUS,
                       SUBSTR(LPAD(E.NRINSJUREMPR, 20,'0'), 12, 9) AS CDEMPINTEGRACAO
                    FROM NOTAFISCAL NF,
                         FILIAL FILIEMIT,
                         FILIAL FILIRECE,
                         ITEMNOTAFISC I, 
                         EMPRESA E
                    WHERE
                        FILIEMIT.CDFILIAL = NF.CDFILIEMIT
                    AND FILIRECE.CDFILIAL = NF.CDFILIRECE
                    AND NF.NRINSJURNF = NVL(:NRINSJURNF, NF.NRINSJURNF)
                    AND NF.NRNOTAFISC = NVL(:NRNOTAFISC, NF.NRNOTAFISC)
                    AND FILIRECE.CDEMPRESA = E.CDEMPRESA
                    AND NF.CDFILIRECE = :CDFILIAL
                    AND NF.NRNOTAFISC IS NOT NULL
                    AND NF.CDFILIAL = I.CDFILIALIT (+)
                    AND NF.NRLANCTONF = I.NRLANCTONFIT (+)
                    AND NF.CDTIPOOPER = '02'
                    AND NF.IDENTRSAIDOP = 'S'
                    AND NF.DTENTRSAID BETWEEN :DTINICIAL AND :DTFINAL
                            ";
                
        $params = array(
            "CDFILIAL" => $CDFILIAL,
            "DTINICIAL" => $DTINICIAL,
            "DTFINAL" => $DTFINAL,
            "NRNOTAFISC" => $NRNOTAFISC,
            "NRINSJURNF" => $NRINSJURGUIA
        );

        $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
        $nfWasFound = $query->fetchAll();
        if(isset($nfWasFound) && !empty($nfWasFound)){
            return $nfWasFound;
        }else{
            return false;
        }
    }
    
    public function getProducts($cdfilial, $nrlanctonf){
        $sql =  " SELECT 
                        P.NMPRODUTO AS NMPRODUTO,
                        P.CDARVPROD AS CDARVPROD, 
                        I.CDPRODUTO AS CDPRODUTO,
                        I.QTITEMPROD AS QTITEMPROD, 
                        I.VRUNITITEM AS VRUNITITEM,
                        I.VRTOTAITEM AS VRTOTAITEM,
                        I.QTITEMPROD AS QTRECEBE,
                        I.CDALMOXARIFE AS CDALMOXARIFE,
                        I.CDLOCALESTOQ AS CDLOCALESTOQ,
                        I.NRLOTEESTQ AS NRLOTEESTQ,
                        I.NRSUBLOTE AS NRSUBLOTE
                    FROM ITEMPRODUTO I,
                         PRODUTO P
                    WHERE CDFILIAL = :CDFILIAL
                        AND NRLANCTONF = :NRLANCTONF
                        AND P.CDPRODUTO = I.CDPRODUTO";
                
        $params = array(
            "CDFILIAL" => $cdfilial,
            "NRLANCTONF" => $nrlanctonf
        );

        $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
        $prodWasFound = $query->fetchAll();
        if(isset($prodWasFound) && !empty($prodWasFound)){
            return $prodWasFound;
        }else{
            return false;
        }
    }
}
