<?php

namespace Modules\PLA\Controllers;

class Cardapio {
  protected $connection;
  protected $environment;
  protected $newCodeNT;
  protected $Utils;
  public function __construct($connection, $environment, $newCodeNT, $UtilsIntegracao){
      $this->connection = $connection;
      $this->environment = $environment;
      $this->newCodeNT = $newCodeNT;
      $this->Utils = $UtilsIntegracao;
  }
  
  public function endpointGetCardapio($request, $response){
        try{
            $cdfilial = $this->Utils->parametro($request, 'CDFILIAL');
            $cdservfili = $this->Utils->parametro($request, 'CDSERVFILI');
            $dtinicial = $this->Utils->parametro($request, 'DTINICIAL');
            if(!$this->Utils->dataValida($dtinicial)){
                $this->Utils->incluiMensagem("Data incial ( $dtinicial ) não é um valor válido", true);
            }
            $dtfinal =$this->Utils->parametro($request, 'DTFINAL');
            if(!$this->Utils->dataValida($dtfinal)){
                $this->Utils->incluiMensagem("Data final ( $dtfinal ) não é um valor válido", true);
            }
            
            $query = "
            SELECT C.CDFILIAL, C.CDSERVFILI, S.NMSERVICO, C.DTCARDAPIO,
                   TP.CDTIPOPRAT, TP.NMTIPOPRAT, P.CDFILAUXPRAT, P.CDPRATO, P.NMPRATO,
                   S.HRINICSERV, S.HRFINASERV
              FROM CARDADIA C
                   INNER JOIN COMPCARD COM ON COM.CDFILIAL = C.CDFILIAL AND
                                             COM.NRCARDAPIO = C.NRCARDAPIO
                   LEFT JOIN CNFCAMES CNF ON CNF.CDFILIAL = C.CDFILIAL AND
                                             CNF.CDSERVFILI = C.CDSERVFILI AND
                                             CNF.DTREFECNFMES = C.DTMESCARD AND
                                             CNF.NRSEQCNFMES = COM.NRSEQPRATCAR
                   LEFT JOIN TIPOPRAT TP ON TP.CDTIPOPRAT = CNF.CDTIPOPRAT
                   LEFT JOIN PRATO P ON P.CDFILAUXPRAT = COM.CDFILAUXPRAT AND
                                        P.CDPRATO = COM.CDPRATO
                   LEFT JOIN SERVICO S ON S.CDFILIAL = C.CDFILIAL AND
                                          S.CDSERVFILI = C.CDSERVFILI
             WHERE C.CDFILIAL = :CDFILIAL
               AND C.CDSERVFILI = :CDSERVFILI
               AND C.DTCARDAPIO BETWEEN :DTINICIAL AND :DTFINAL
             ORDER BY CDFILIAL,CDSERVFILI, DTCARDAPIO, CNF.NRORDCNFMES
            ";
            $params = [
                "CDFILIAL" => $cdfilial,
                "CDSERVFILI" => $cdservfili,
                "DTINICIAL" => $dtinicial,
                "DTFINAL" => $dtfinal
            ];
            
            if($this->Utils->statusAtual() == 'E'){
                $this->Utils->retornoJSONStatusMensagem($response);
                return;    
            }
            
            $prepared = $this->connection->prepare($query);
            $prepared->execute($params);
            $data = $prepared->fetchAll();
            $this->Utils->retornoJSON($response, $data);
        }catch(\Exception $e){
            if($this->Utils->modoDesenvolvedor())
                throw $e;
            $this->Utils->incluiMensagem("Ocorreu um erro não esperado na execução da rotina. Verifique os parâmetros e tente novamente", true);
            $this->Utils->retornoJSONStatusMensagem($response);
        }
    }
}