/* Tecnisa - Tecnologia em Informtica

 Nome: 0316_CUSFUN_CUSTO_PRODUTO

 Descrio:
 Funo para clculo do custo do produto de acordo com a tabela TIPOCUSTO
_________________________________________________________________________
_________________________________________________________________________
   01 Custo Mdio Lquido Atual
   02 Custo Mdio Bruto Atual
   03 Custo Mdio Lquido da poca
   04 Custo Mdio Bruto da poca
   05 Custo da ltima Compra (NF)
   06 Custo de Cotao (Lista de Preos)
   07 Custo da ltima compra(AF)
   20 Custo Mdio Lquido Atual
   21 Custo Mdio Lquido Atual
   22 Custo Mdio Bruto Atual
   23 Custo Mdio Bruto Atual
   24 Custo Mdio Lquido da poca
   25 Custo Mdio Lquido da poca
   26 Custo Mdio Bruto da poca
   27 Custo Mdio Bruto da poca
   28 Custo da ltima Compra (NF)
   29 Custo da ltima Compra (NF)
   30 Custo de Cotao (Lista de Preos)
   31 Custo de Cotao (Lista de Preos)
   32 Custo da ltima Compra(AF)
   33 Custo da ltima Compra(AF)
   34 Custo Mdio Atualizado
   35 Custo Mdio Atualizado
_________________________________________________________________________
_________________________________________________________________________

 Criao:
 13/10/2003 - Roberto A. Lopes Martins

 @C:\Win_V4\Sql\End_Conv\Oracle\0400_CUSFUNO.SQL
*/

CREATE OR REPLACE FUNCTION CUSTO_GLOBAL(
   P_CDPRODUTO    IN PRODUTO.CDPRODUTO%TYPE,
   P_NRTIPOCUSTO  IN NUMBER,
   P_DTREFERENCIA IN DATE, 
   P_DTATUAL      IN DATE) RETURN NUMBER IS

   V_VRCUSTO      NUMBER;
   V_DTREFERENCIA DATE;

   V_QTESTDIACON    POSESTCONS.QTESTDIACON%TYPE;
   V_QTESTANTCON    POSESTCONS.QTESTANTCON%TYPE;
   V_VRESTDIACON    POSESTCONS.VRESTDIACON%TYPE;
   V_VRESTDIACOM1   POSESTCONS.VRESTDIACOM1%TYPE;
   V_VRESTDIACOM2   POSESTCONS.VRESTDIACOM2%TYPE;
   V_VRESTANTCON    POSESTCONS.VRESTANTCON%TYPE;
   V_VRESTANTCOM1   POSESTCONS.VRESTANTCOM1%TYPE;
   V_VRESTANTCOM2   POSESTCONS.VRESTANTCOM2%TYPE;
   V_VRESTBRUTCON   POSESTCONS.VRESTBRUTCON%TYPE;
   V_VRESTBRUTCM1   POSESTCONS.VRESTBRUTCM1%TYPE;
   V_VRESTBRUTCM2   POSESTCONS.VRESTBRUTCM2%TYPE;
   V_VRBRUTANTCON   POSESTCONS.VRBRUTANTCON%TYPE;
   V_VRBRUTANTCM1   POSESTCONS.VRBRUTANTCM1%TYPE;
   V_VRBRUTANTCM2   POSESTCONS.VRBRUTANTCM2%TYPE;

   V_VRULTCOMPR     PRODFILI.VRULTCOMPR%TYPE;
   V_VRULTCOMPRM1   PRODFILI.VRULTCOMPRM1%TYPE;
   V_VRULTCOMPRM2   PRODFILI.VRULTCOMPRM2%TYPE;

   V_VRCUSPRLISTP   CUSTOSUP.VRCUSPRLISTP%TYPE;
   V_VRCUSPRLISM1   CUSTOSUP.VRCUSPRLISM1%TYPE;
   V_VRCUSPRLISM2   CUSTOSUP.VRCUSPRLISM2%TYPE;
   V_VRPRCUSTOAF    CUSTOSUP.VRPRCUSTOAF%TYPE;
   V_VRPRCUSAFM1    CUSTOSUP.VRPRCUSAFM1%TYPE;
   V_VRPRCUSAFM2    CUSTOSUP.VRPRCUSAFM2%TYPE;

   V_IDUTILDTPROC   VARCHAR2(1);
BEGIN

   V_VRCUSTO := 0;

   IF P_NRTIPOCUSTO IN (1,2,3,4,20,21,22,23,24,25,26,27) THEN /*Custos que tem valores na tabela POSESTCONS*/

      V_DTREFERENCIA := P_DTREFERENCIA;                 /*Custo Mdio da poca*/

      SELECT NVL(MAX(QTESTDIACON),0), NVL(MAX(QTESTANTCON),0), NVL(MAX(VRESTDIACON),0),
             NVL(MAX(VRESTDIACOM1),0), NVL(MAX(VRESTDIACOM2),0), NVL(MAX(VRESTANTCON),0),
             NVL(MAX(VRESTANTCOM1),0), NVL(MAX(VRESTANTCOM2),0), NVL(MAX(VRESTBRUTCON),0),
             NVL(MAX(VRESTBRUTCM1),0), NVL(MAX(VRESTBRUTCM2),0), NVL(MAX(VRBRUTANTCON),0),
             NVL(MAX(VRBRUTANTCM1),0), NVL(MAX(VRBRUTANTCM2),0)
      INTO V_QTESTDIACON, V_QTESTANTCON, V_VRESTDIACON,
           V_VRESTDIACOM1, V_VRESTDIACOM2, V_VRESTANTCON,
           V_VRESTANTCOM1, V_VRESTANTCOM2, V_VRESTBRUTCON,
           V_VRESTBRUTCM1, V_VRESTBRUTCM2, V_VRBRUTANTCON,
           V_VRBRUTANTCM1, V_VRBRUTANTCM2
      FROM POSESTCONS P
      WHERE CDPRODUTO   = P_CDPRODUTO AND
            DTPOSESTCON = (SELECT MAX(DTPOSESTCON)
                           FROM POSESTCONS PD
                           WHERE CDPRODUTO = P_CDPRODUTO AND
                                 DTPOSESTCON <= (V_DTREFERENCIA+1));
      IF (V_QTESTDIACON <> 0) THEN
         V_VRESTDIACON  := (V_VRESTDIACON/V_QTESTDIACON);
         V_VRESTDIACOM1 := (V_VRESTDIACOM1/V_QTESTDIACON);
         V_VRESTDIACOM2 := (V_VRESTDIACOM2/V_QTESTDIACON);
         V_VRESTBRUTCON := (V_VRESTBRUTCON/V_QTESTDIACON);
         V_VRESTBRUTCM1 := (V_VRESTBRUTCM1/V_QTESTDIACON);
         V_VRESTBRUTCM2 := (V_VRESTBRUTCM2/V_QTESTDIACON);
      ELSIF (V_QTESTANTCON <> 0) THEN
         V_VRESTDIACON  := (V_VRESTANTCON/V_QTESTANTCON);
         V_VRESTDIACOM1 := (V_VRESTANTCOM1/V_QTESTANTCON);
         V_VRESTDIACOM2 := (V_VRESTANTCOM2/V_QTESTANTCON);
         V_VRESTBRUTCON := (V_VRBRUTANTCON/V_QTESTANTCON);
         V_VRESTBRUTCM1 := (V_VRBRUTANTCM1/V_QTESTANTCON);
         V_VRESTBRUTCM2 := (V_VRBRUTANTCM2/V_QTESTANTCON);
      ELSE
         V_VRESTDIACON  := 0;
         V_VRESTDIACOM1 := 0;
         V_VRESTDIACOM2 := 0;
         V_VRESTBRUTCON := 0;
         V_VRESTBRUTCM1 := 0;
         V_VRESTBRUTCM2 := 0;
      END IF;

      IF P_NRTIPOCUSTO IN (1,3) THEN      /*Custo Mdio Lquido*/
         V_VRCUSTO := V_VRESTDIACON;
      ELSIF P_NRTIPOCUSTO IN (2,4) THEN   /*Custo Mdio Bruto*/
         V_VRCUSTO := V_VRESTBRUTCON;
      ELSIF P_NRTIPOCUSTO IN (20,24) THEN /*Custo Mdio Lquido (ndice 01)*/
         V_VRCUSTO := V_VRESTDIACOM1;
      ELSIF P_NRTIPOCUSTO IN (21,25) THEN /*Custo Mdio Lquido (ndice 02)*/
         V_VRCUSTO := V_VRESTDIACOM2;
      ELSIF P_NRTIPOCUSTO IN (22,26) THEN /*Custo Mdio Bruto (ndice 01)*/
         V_VRCUSTO := V_VRESTBRUTCM1;
      ELSIF P_NRTIPOCUSTO IN (23,27) THEN /*Custo Mdio Bruto (ndice 02)*/
         V_VRCUSTO := V_VRESTBRUTCM2;
      END IF;


      IF P_NRTIPOCUSTO = 6 THEN           /*Custo de Cotao (Lista de Preos)*/
         V_VRCUSTO := V_VRCUSPRLISTP;
      ELSIF P_NRTIPOCUSTO = 7 THEN        /*Custo da ltima compra(AF)*/
         V_VRCUSTO := V_VRPRCUSTOAF;
      ELSIF P_NRTIPOCUSTO = 30 THEN       /*Custo de Cotao (Lista de Preos) (ndice 01)*/
         V_VRCUSTO := V_VRCUSPRLISM1;
      ELSIF P_NRTIPOCUSTO = 31 THEN       /*Custo de Cotao (Lista de Preos) (ndice 02)*/
         V_VRCUSTO := V_VRCUSPRLISM2;
      ELSIF P_NRTIPOCUSTO = 32 THEN       /*Custo da ltima Compra(AF) (ndice 01)*/
         V_VRCUSTO := V_VRPRCUSAFM1;
      ELSIF P_NRTIPOCUSTO = 33 THEN       /*Custo da ltima Compra(AF) (ndice 02)*/
         V_VRCUSTO := V_VRPRCUSAFM2;
      END IF;

   END IF;

   RETURN(V_VRCUSTO);
END;
/

