/* Sistemas Integrados TEKNISA
  Controle de Produo

Nome: 3924_CDPSTP0.SQL

Descrio:
Rotina para gerao de Ordem de Produo (OP) para os semiacabados industrializados
e seus semiacabados, etc...

@C:\Web_585\Sql\End_Conv\Oracle\3924_CDPSTPO_GERA_OP_SEMIACABADO.SQL

PARA DEBUGAR
-- SET SERVEROUTPUT ON
-- DBMS_OUTPUT.PUT_LINE('xx');
-- raise_application_error(-20501, '**'||V_NRORDPROD||'**', True);

Criao:
15/07/2015 - Srgio Pow Gomes
*/
create or replace PROCEDURE GERA_OP_SEMIACABADO
   (P_CDFILIAL        IN ORDPRODUCAO.CDFILIAL%TYPE,
    P_CDPRODUTO       IN ORDPRODUCAO.CDPRODUTO%TYPE,
    P_CDPROCFABRIC    IN ORDPRODUCAO.CDPROCFABRIC%TYPE,
    P_IDSITORDPROD    IN ORDPRODUCAO.IDSITORDPROD%TYPE,
    P_IDTIPORDPROD    IN ORDPRODUCAO.IDTIPORDPROD%TYPE,
    P_DTGERORDPROD    IN ORDPRODUCAO.DTGERORDPROD%TYPE,
    P_DTVALIDADE      IN ORDPRODUCAO.DTGERORDPROD%TYPE,
    P_QTAPRODPREOP    IN ORDPRODUCAO.QTAPRODPREOP%TYPE,
    P_DSORDPROD       IN ORDPRODUCAO.DSORDPROD%TYPE,
    P_CDPLANPRODOP    IN ORDPRODUCAO.CDPLANPRODOP%TYPE,
    P_IDCONFIRMAOP    IN ORDPRODUCAO.IDCONFIRMAOP%TYPE,
    P_NRPEDIDO        IN ORDPRODUCAO.NRPEDIDO%TYPE,
    P_NRITEMPED       IN ORDPRODUCAO.NRITEMPED%TYPE,
    P_IDLOTEPRETAP    IN INSUMETAPA.IDLOTEPRETAP%TYPE  DEFAULT 'N',
    P_IDSUBOPINSU     IN INSUMETAPA.IDSUBOPINSU%TYPE   DEFAULT 'N',
    P_NRORDPROD       IN ORDPRODUCAO.NRORDPROD%TYPE    DEFAULT NULL,
    P_NRSUBORDPROD    IN ORDPRODUCAO.NRSUBORDPROD%TYPE DEFAULT NULL,
    P_NRLOTEESTQ      IN LOTE.NRLOTEESTQ%TYPE DEFAULT NULL,
    P_NRSEQTRABPEDIDOOP IN TRABPEDIDOOP.NRSEQTRABPEDIDOOP%TYPE DEFAULT NULL,
    P_CDPRODORIGEM    IN PRODUTO.CDPRODUTO%TYPE DEFAULT NULL
   ) AS
   V_DSNUMELOTEPR   PARAMAN.DSNUMELOTEPR%TYPE;
   V_DSSEQULOTEPR   PARAMAN.DSSEQULOTEPR%TYPE;
   V_SEQNRORDPROD   VARCHAR2(20);
   V_NRORDPROD      ORDPRODUCAO.NRORDPROD%TYPE;
   V_NRLOTEESTQ     LOTE.NRLOTEESTQ%TYPE;
   V_NRSUBLOTE      LOTE.NRSUBLOTE%TYPE;
   V_NRORDENASUBOP  CALEPRODMRP.NRORDENAOP%TYPE;
   V_IDSUBOPSEMIACA PARAMAN.IDSUBOPSEMIACA%TYPE;
   V_IDENTRSEQ      CHAR;
   V_IDUTEQUIPLAPROD PARAMAN.IDUTEQUIPLAPROD%TYPE;
   V_QTPADPROCFAB   FLOAT;
   V_CONTGEROP      FLOAT;
   V_QTDEOP         FLOAT;
   V_IDTPPROPOPF    VARCHAR2(1);
   V_IDTPARREDPF    VARCHAR2(1);
   V_CONTADOR       NUMBER;
   V_CONTADOR2      NUMBER;
   V_NRLOTEEXIST    LOTE.NRLOTEESTQ%TYPE;
   V_CDPRODEMANDA   PRODUTO.CDPRODUTO%TYPE;
   V_QTSEMIACAB     FLOAT;
   V_QTESTOQUE      FLOAT;
   V_CDARVPROD      PRODUTO.CDARVPROD%TYPE;
   V_NMPRODUTO      PRODUTO.NMPRODUTO%TYPE;
   V_CDPROCFABRIC   PROCFABRICA.CDPROCFABRIC%TYPE;
BEGIN
   /* Verifica parmetros do manufatura */
    SELECT
      MAX(DSNUMELOTEPR),
      MAX(DSSEQULOTEPR),
      NVL(MAX(IDSUBOPSEMIACA),'N'),
      MAX(NVL(IDENTRSEQLOTE,'N')),
      MAX(NVL(IDUTEQUIPLAPROD, 'N'))
    INTO
      V_DSNUMELOTEPR,
      V_DSSEQULOTEPR,
      V_IDSUBOPSEMIACA,
      V_IDENTRSEQ,
      V_IDUTEQUIPLAPROD
    FROM
      PARAMAN M, PARAMFILIAL F
    WHERE
      M.CDFILIAL = P_CDFILIAL    AND
      M.CDFILIAL = F.CDFILIAL;

    BEGIN
       SELECT QTPADPROCFAB, IDTPPROPOPF, IDTPARREDPF, CDPROCFABRIC
         INTO V_QTPADPROCFAB, V_IDTPPROPOPF, V_IDTPARREDPF, V_CDPROCFABRIC
         FROM PROCFABRICA
        WHERE CDFILIAL  = P_CDFILIAL
          AND CDPRODUTO = P_CDPRODUTO
          AND IDPROFABPADR = 'S';
    EXCEPTION
       WHEN NO_DATA_FOUND THEN BEGIN
          V_QTPADPROCFAB := NULL;
          V_IDTPPROPOPF  := NULL;
          V_IDTPARREDPF  := NULL;
       END;
    END;
    
    
    IF ((NOT V_QTPADPROCFAB IS NULL) OR (NOT V_QTPADPROCFAB = 0)) THEN 
    
        V_CONTADOR  := 1;
        V_CONTADOR2 := 1;
        V_CONTGEROP := 0;
    
        V_CONTGEROP := P_QTAPRODPREOP / V_QTPADPROCFAB;
        V_CONTGEROP := TRUNC(V_CONTGEROP + 1);
        V_QTDEOP    := P_QTAPRODPREOP;
    
        IF V_QTDEOP > 0 THEN
            /* Gera o nmero do Lote de Produo */
            IF (P_IDLOTEPRETAP = 'N') THEN
               PRXLOTEPROD(P_CDFILIAL, P_DTVALIDADE, P_CDPRODUTO, V_NRLOTEESTQ);
            ELSE
               V_NRLOTEESTQ := P_NRLOTEESTQ;
            END IF;
            /* Gera o nmero da OP/SubOP */
            IF (P_IDSUBOPINSU = 'N') THEN
               NOVO_CODIGO_SC('NRORDPROD'||P_CDFILIAL, V_SEQNRORDPROD, 1);
               V_NRORDPROD     := SUBSTR(V_SEQNRORDPROD, 11, 10);
               V_NRORDENASUBOP := '0';
            ELSE
               V_NRORDPROD     := P_NRORDPROD;
               V_NRORDENASUBOP := TO_CHAR(TO_NUMBER(P_NRSUBORDPROD)+1);
            END IF;
            V_NRSUBLOTE     := ' ';
    
            BEGIN
                SELECT
                   MAX(NRLOTEESTQ)
                INTO
                   V_NRLOTEEXIST
                FROM
                   LOTE
                WHERE
                   CDFILIAL     = P_CDFILIAL    AND
                   CDPRODUTO    = P_CDPRODUTO   AND
                   NRLOTEESTQ   = V_NRLOTEESTQ;
            EXCEPTION
                WHEN NO_DATA_FOUND THEN BEGIN
                    V_NRLOTEEXIST := NULL;
                END;
            END;
    
    
            IF V_NRLOTEEXIST IS NULL THEN
               INSERT INTO LOTE
                   (CDFILIAL, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO, IDSTATLOTE,
                   DTENTRLOTE, DTVALILOTE, IDSTPRODLOTE, CDPLANPRODLT)
               VALUES
                   (P_CDFILIAL, V_NRLOTEESTQ, V_NRSUBLOTE, P_CDPRODUTO, 'I',
                    P_DTGERORDPROD, P_DTVALIDADE, '1', P_CDPLANPRODOP);
            END IF;
    
            INSERT INTO ORDPRODUCAO
                 (CDFILIAL, NRORDPROD, NRSUBORDPROD, CDPRODUTO, CDPROCFABRIC,
                   IDSITORDPROD, IDTIPORDPROD, DTGERORDPROD, QTAPRODPREOP,
                  DTHRINIPREOP, NRLOTEESTQ, NRSUBLOTE, DSORDPROD, CDPLANPRODOP, IDCONFIRMAOP,
                  NRPEDIDO, NRITEMPED)
            VALUES
                 (P_CDFILIAL, V_NRORDPROD, V_NRORDENASUBOP, P_CDPRODUTO,  V_CDPROCFABRIC,
                  P_IDSITORDPROD, P_IDTIPORDPROD, P_DTGERORDPROD, V_QTDEOP,
                  P_DTGERORDPROD, V_NRLOTEESTQ, V_NRSUBLOTE, P_DSORDPROD, P_CDPLANPRODOP, P_IDCONFIRMAOP,
                  P_NRPEDIDO, P_NRITEMPED);
    
            INSERT INTO TRABPEDIDOOPSEMI
                 (CDFILIAL, NRSEQTRABPEDIDOOP, CDPRODUTO, CDPRODINSUMO, NRORDPROD, NRSUBORDPROD)
            VALUES
                 (P_CDFILIAL, P_NRSEQTRABPEDIDOOP, P_CDPRODORIGEM, P_CDPRODUTO,  V_NRORDPROD, V_NRORDENASUBOP);
    
            BEGIN
               SELECT CDARVPROD, NMPRODUTO
                 INTO V_CDARVPROD, V_NMPRODUTO
                 FROM PRODUTO
                WHERE CDPRODUTO = P_CDPRODORIGEM;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN BEGIN
                  V_CDARVPROD := NULL;
                  V_NMPRODUTO := NULL;
               END;
            END;
    
            UPDATE ORDPRODUCAO
               SET DSORDPROD = DSORDPROD || ' Ordem de Produo de Semicabado do Produto : '||V_CDARVPROD||' - '||V_NMPRODUTO
             WHERE CDFILIAL = P_CDFILIAL
               AND NRORDPROD = V_NRORDPROD
               AND NRSUBORDPROD = V_NRORDENASUBOP;
    
        END IF;
    
       /* Verifica se h algum semiacabado na composio deste produto */
        FOR C_SEMIACABADO IN (
                              SELECT I.CDPRODUTO   ,
                                     I.CDETAPAPROD ,
                                     I.CDPRODINSUMO,
                                     F.CDPROCFABRIC,
                                     (SYSDATE) AS DTVALIDADE,
                                     I.IDUTAPRREQET,
                                     I.IDSEMIACETAP,
                                     I.QTINSUMETAPA,
                                     I.QTRENDINSU  ,
                                     O.QTAPRODPREOP,
                                     NVL(I.IDLOTEPRETAP,'N') IDLOTEPRETAP,
                                     NVL(I.IDSUBOPINSU,'N') IDSUBOPINSU,
                                     QTPREVI_MATPRIMA(I.CDFILIAL, I.CDPRODUTO, I.CDPROCFABRIC, I.CDETAPAPROD, I.CDPRODINSUMO, O.QTAPRODPREOP) AS QTAINSUMPREOP
                                FROM ORDPRODUCAO O,
                                     PROCFABRICA F,
                                     INSUMETAPA  I
                               WHERE (I.IDSEMIACETAP = 'S'            )
                                 AND (F.IDPROFABPADR = 'S'            )
                                 AND (F.CDFILIAL     = I.CDFILIAL     )
                                 AND (F.CDPRODUTO    = I.CDPRODINSUMO )
                                 AND (O.CDFILIAL     = I.CDFILIAL     )
                                 AND (O.CDPRODUTO    = I.CDPRODUTO    )
                                 AND (O.CDPROCFABRIC = I.CDPROCFABRIC )
                                 AND (O.CDFILIAL     = P_CDFILIAL     )
                                 AND (O.NRORDPROD    = V_NRORDPROD    )
                                 AND (O.NRSUBORDPROD = V_NRORDENASUBOP)
                                 AND (O.CDPRODUTO    = P_CDPRODUTO   )
                                 AND (O.CDPROCFABRIC = P_CDPROCFABRIC)
                               ORDER BY I.CDETAPAPROD, I.CDPRODINSUMO
                              ) LOOP
    
          IF C_SEMIACABADO.QTAINSUMPREOP > 0 THEN
             V_QTSEMIACAB := 0;
    
             -- Consulta tabela temporria de estoque.
             BEGIN
                SELECT CDPRODUTO, QTESTOQUE
                  INTO V_CDPRODEMANDA, V_QTESTOQUE
                  FROM ESTSEMIACAB
                 WHERE (CDFILIAL  = P_CDFILIAL)
                   AND (NRPEDIDO  = P_NRPEDIDO)
                   AND (CDPRODUTO = C_SEMIACABADO.CDPRODINSUMO);
             EXCEPTION
                WHEN NO_DATA_FOUND THEN
                   V_CDPRODEMANDA := '';
                   V_QTESTOQUE    := 0;
             END;
    
             IF V_QTESTOQUE > 0 THEN
                V_QTSEMIACAB := C_SEMIACABADO.QTAINSUMPREOP - V_QTESTOQUE;
    
                IF (V_QTESTOQUE - C_SEMIACABADO.QTAINSUMPREOP) > 0 THEN
                   -- Altera a quantidade de estoque deste produto.
                   UPDATE ESTSEMIACAB
                      SET QTESTOQUE  = V_QTESTOQUE - C_SEMIACABADO.QTAINSUMPREOP
                    WHERE (CDFILIAL  = P_CDFILIAL)
                      AND (NRPEDIDO  = P_NRPEDIDO)
                      AND (CDPRODUTO = C_SEMIACABADO.CDPRODINSUMO);
                ELSE
                   -- Zera a quantidade de estoque deste produto.
                   UPDATE ESTSEMIACAB
                      SET QTESTOQUE  = 0
                    WHERE (CDFILIAL  = P_CDFILIAL)
                      AND (NRPEDIDO  = P_NRPEDIDO)
                      AND (CDPRODUTO = C_SEMIACABADO.CDPRODINSUMO);
                END IF;
    
             ELSE
                V_QTSEMIACAB := C_SEMIACABADO.QTAINSUMPREOP;
             END IF;
    
             IF V_QTSEMIACAB > 0 THEN
                /* Chama a mesma GERA_OP_SEMIACABADO recursivamente gerando OP para os semiacabados dos semiacabados */
                GERA_OP_SEMIACABADO(P_CDFILIAL, C_SEMIACABADO.CDPRODINSUMO, C_SEMIACABADO.CDPROCFABRIC, '1', '3', P_DTGERORDPROD, C_SEMIACABADO.DTVALIDADE,
                                    C_SEMIACABADO.QTAINSUMPREOP, P_DSORDPROD, P_CDPLANPRODOP, P_IDCONFIRMAOP, P_NRPEDIDO, P_NRITEMPED,
                                    C_SEMIACABADO.IDLOTEPRETAP, C_SEMIACABADO.IDSUBOPINSU, V_NRORDPROD, V_NRORDENASUBOP,  V_NRLOTEESTQ,
                                    P_NRSEQTRABPEDIDOOP, P_CDPRODUTO);
             END IF;
          END IF;
       END LOOP;
    END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GERA_OP_SEMIACABADO','6.49.068'); END;
/
